#define ENABLE_GxEPD2_GFX 0
#include <GxEPD2_BW.h>
#include <U8g2_for_Adafruit_GFX.h>
#include <TinyGPS++.h>
#include <HardwareSerial.h>
#include <SPI.h>
#include <Adafruit_BMP280.h>
#include "MPU9250.h"
#include <WiFi.h>
#include <ArduinoOTA.h>
#include "CircularBuffer.h"
#include "Timer.h"
#include "ImAloha.h"

const int nbvitessesbuffer=110;
CircularBuffer<float, nbvitessesbuffer> vitesseBuffer;

MPU9250 IMU(Wire,0x68);
int status;

Timer t;

Adafruit_BMP280 bmp; // use I2C interface

float temperature, pression;

HardwareSerial serialgps (1);

TinyGPSPlus gps;

const int boutonselaff=34;
const int boutonselmob=39;
const int boutonselintensiteLED=35;
const int mesureloch=36;

long tempsantirebond = 50; //En Milliseconds
unsigned long last_micros;

#define rxgps 14
#define txgps 33

float gpslatitude;
float gpslongitude;
int gpsheureGTC;
int gpsheureloc;
int GTCdec;
int gpsminute;
int gpsseconde;
int gpsjour;
int gpsmois;
int gpsannee;
float gpsvitesseknt;
float gpscap;
int gpsnbsat;

float MOBlat;
float MOBlong;

float distancedumob;
float capaprendremob;

String mobflechegauche;
String mobflechedroite;

unsigned long debutcycleloch=0;
unsigned long comptviteau=0;
float vitesseeauknt=0;


GxEPD2_BW<GxEPD2_420, GxEPD2_420::HEIGHT> display(GxEPD2_420(/*CS=5*/ SS, /*DC=*/ 17, /*RST=*/ 16, /*BUSY=*/ 4));

U8G2_FOR_ADAFRUIT_GFX u8g2Fonts;

uint16_t bg = GxEPD_WHITE;
uint16_t fg = GxEPD_BLACK;

byte a=0;
byte b=0;
int tempsraz=0;

float xMagnetMax=10;
float yMagnetMax=10;
float zMagnetMax=10;

float xMagnetMin=0;
float yMagnetMin=0;
float zMagnetMin=0;

float xMagnetMap=0;
float yMagnetMap=0;
float zMagnetMap=0;

float capm=0;

double roulis,tangage;

float vitessesolmoyknt=0;
float vitessesolmaxknt=0;
float tableauvitessesol[10];
int indicetableauvitesse = 0;
float vitessesollisse=0;
float distance=0;

unsigned long debut=0;
unsigned long maintenant=0;
float interval=0;
float nombresecondes=0;

int nbjours;
int nbheures;
int nbminutes;
int nbsecondes;

const int ledPin = 0;

const int freq = 5000;
const int ledChannel = 0;
const int resolution = 4;

const char* ssid = "AlohaGPS";
const char* password = "ConnectAloha";

bool statusmob = LOW;

#include "Fonctionsloch.h"
#include "Fonctionsaffichage.h"
#include "FonctionsGPS.h"
#include "Fonctionscalculs.h"
#include "Fonctionsboutons.h"
#include "FonctionsLED.h"

void setup()
{
  
  WiFi.mode(WIFI_AP);
  WiFi.softAP(ssid,password);
  ArduinoOTA.setHostname("BoitierGPS");
  ArduinoOTA.begin();

  t.every(500, affichage);

  statusmob = LOW;

  for (int i=0;i < nbvitessesbuffer;i++) vitesseBuffer.push(0);
  
  ledcSetup(ledChannel, freq, resolution);
  ledcAttachPin(ledPin, ledChannel);
  
  status = IMU.begin();

  bmp.begin(0x76);
  
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, LOW);
    
  Serial.begin(115200);

  initboutons();
  
  initaff();
  
  initGPS();

  debutcycleloch=millis();
  
}


void loop()
{

  ArduinoOTA.handle();

  t.update();
  
  lectureGPS();

  decodageinfosGPS();

  calculloch();
 
  intensiteLED();
  
  IMU.readSensor();

  calculenvir();

  calculcapm();

  calculattitude();

  calculmoydist();

  if (statusmob == HIGH) mob();
  
  
}
